//+------------------------------------------------------------------+
//|                                              SHMEN-DASHBOARD.mq4 |
//|                                                            Bendo |
//|                                               http://www.done.ca |
// Always appreciate donations that are paypalled to: bendo@shaw.ca

//+------------------------------------------------------------------+
#property copyright "Bendo"
#property link      "http://www.done.ca"
// Always appreciate donations that are paypalled to: bendo@shaw.ca

#include <stdlib.mqh>
#include <stderror.mqh>


//---- input parameters

//extern int       Targets=2;
extern int       Max_Slip=1000;
//extern int       Units_Per_Trade=1;


extern double    Standard_Lot_Size;

//extern bool      Market_Orders=True;
//extern bool      Resting_Orders=True;
extern bool      Action_Line=false;
extern int       Lot_Precision=2; // 1 for minilots, 2 for microlots, 3 for nano, 0 for standard
extern int      Risk_Management=0; // 0 = Standard LotSize is Actual Lotsize....1 = Standard LotSize is a portion of equity....2 = Complex LotSizes
extern string Com = "J"; //comments for orders.
extern int   Default_Stop; 
extern int   Default_Take1;
//extern int   Default_Take2;
//extern int   Default_Take3;
//extern int   Default_Take4;

extern int  Y_Adjust=20; // adjust this to space out the verticle space between icons
extern double  X_Adjust=1.5; // adjust this to change the horizontal space between icons.
extern double   Bottom_Adjust = 14; // adjust this to shift the controls up or down.
//extern color   Arrow_Color;
extern double  RR_Center = 5; // adjust this to center the Risk:Reward Text Object
extern double  ST_Center = 5; // adjust this to center the Selected Trade text
extern double  LS0_Center = 5; // adjust this to center Lots Text
extern double  LS1_Center = 8; // adjust this to center Lots Text in % risk mode
extern color Text_Color=White;

extern string Font = "Times New Roman"; 
extern string COMMENT_TryTheseFonts = "Try these fonts: Arial ,  Comic Sans MS , Courier ,  Modern , Roman , Georgia , Verdana" ;

extern int Font_Size=10;
//extern int Icon_Size=1;
extern int SleepTimer=1000;

double   Lot_Size;
double   Stop_Loss;
double   Entry;
double   TStop;
double   AlertP;
double   TTake1;
double   TTake2;
double   TTake3;
double   TTake4;
double   Target1;
double   Target2;
double   Target3;
double   Target4;
double   Resting_Target; 
double   Risk_Reward;



int   MagicNumber = 77777;
int   Select = -1, ASymbol, OResult;
double   Pips_Deposit;
double Bottom_Fly;
bool  Action_Taken=true,Shifted=false, NoTradeFound = true;
string XSymbol;
string Comment_Text;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

XSymbol = Symbol();
Select = -1;
if (XSymbol == "USDJPY") ASymbol = 1;
if (XSymbol == "USDCAD") ASymbol = 2;
if (XSymbol == "USDCHF") ASymbol = 3;
if (XSymbol == "GBPUSD") ASymbol = 4;
if (XSymbol == "AUDUSD") ASymbol = 5;
if (XSymbol == "GBPJPY") ASymbol = 6;
if (XSymbol == "EURJPY") ASymbol = 7;
if (XSymbol == "USDCAD") ASymbol = 8;
if (XSymbol == "USDCHF") ASymbol = 9;
if (XSymbol == "XAGUSD") ASymbol = 10;
if (XSymbol == "XAUUSD") ASymbol = 11;
if (XSymbol == "NZDUSD") ASymbol = 12;
if (XSymbol == "AUDNZD") ASymbol = 13;
if (XSymbol == "EURGBP") ASymbol = 14;
if (XSymbol == "EURCHF") ASymbol = 15;
if (XSymbol == "CHFJPY") ASymbol = 16;
if (XSymbol == "GBPCHF") ASymbol = 17;
if (XSymbol == "AUDCAD") ASymbol = 18;
if (XSymbol == "EURUSD") ASymbol = 19;
if (XSymbol == "USDMXN") ASymbol = 20;
if (XSymbol == "USDTRY") ASymbol = 21;
if (XSymbol == "CADJPY") ASymbol = 22;
if (XSymbol == "AUDJPY") ASymbol = 23;
if (XSymbol == "EURCAD") ASymbol = 24;
if (XSymbol == "EURAUD") ASymbol = 25;


Pips_Deposit = AccountEquity( ) ;
//Alert("Pips Value"+Pips_Deposit);

Risk_Management= GlobalVariableGet("G_Risk_Management");
Standard_Lot_Size= GlobalVariableGet("G_Lot_Size");
      Update_Board();
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   GlobalVariableSet("G_Lot_Size", Standard_Lot_Size);
   GlobalVariableSet("G_Risk_Management", Risk_Management);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   while (!IsStopped())
   {
      RefreshRates();
      Check_For_Inputs();
      Update_Board();
      Recalculate_Risk(); // and check for alerts
      WindowRedraw();
      Sleep(SleepTimer);
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+

void Update_Board()
{ 
   double Top = WindowPriceMax();
   double Price_Unit = (Top-WindowPriceMin())/ Y_Adjust;
   double Bottom = WindowPriceMin()+ ((Bottom_Adjust+Bottom_Fly)*Price_Unit);
   datetime Time_Unit = Period()*(WindowBarsPerChart( )/ X_Adjust );
   if (OrderTicket() > 1 && !NoTradeFound && OrderSymbol() == Symbol()) 
      {
      OrderSelect(Select,SELECT_BY_POS);
      string PoType;
      double R, P;
      double W, B;
      switch (OrderType()) 
         {
         case OP_BUY: PoType = "OPEN BUY"; 
            if (OrderStopLoss() != 0)
               {
               R = (Bid - OrderStopLoss()) / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               W = (OrderStopLoss() - OrderOpenPrice())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
            if (OrderTakeProfit() !=0)
               {
               P = (OrderTakeProfit() - Bid) / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               B = (OrderTakeProfit() - OrderOpenPrice())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
         break;
         case OP_SELL: PoType = "OPEN SELL"; 
            if (OrderStopLoss() != 0)
               {
               R = (OrderStopLoss() - Ask) / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               W = (OrderOpenPrice() - OrderStopLoss())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
            if (OrderTakeProfit() !=0)
               {
               P = (Ask - OrderTakeProfit()) / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               B = (OrderOpenPrice() - OrderTakeProfit())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
         break;
         case OP_BUYLIMIT: PoType = "RESTING BUY LIMIT"; 
            if (OrderStopLoss() != 0)
               {
               R = 0;
               W = (OrderStopLoss() - OrderOpenPrice())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
            if (OrderTakeProfit() !=0)
               {
               P = 0;
               B = (OrderTakeProfit() - OrderOpenPrice())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
         break;
         case OP_SELLLIMIT: PoType = "RESTING SELL LIMIT"; 
            if (OrderStopLoss() != 0)
               {
               R = 0;
               W = (OrderOpenPrice() - OrderStopLoss())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
            if (OrderTakeProfit() !=0)
               {
               P = 0;
               B = (OrderOpenPrice() - OrderTakeProfit())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
         break;
         case OP_BUYSTOP: PoType = "RESTING BUY STOP"; 
            if (OrderStopLoss() != 0)
               {
               R = 0;
               W = (OrderStopLoss() - OrderOpenPrice())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
            if (OrderTakeProfit() !=0)
               {
               P = 0;
               B = (OrderTakeProfit() - OrderOpenPrice())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
         break;
         case OP_SELLSTOP: PoType = "RESTING SELL STOP"; 
            if (OrderStopLoss() != 0)
               {
               R = 0;
               W = (OrderOpenPrice() - OrderStopLoss())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
            if (OrderTakeProfit() !=0)
               {
               P = 0;
               B = (OrderOpenPrice() - OrderTakeProfit())  / MarketInfo (Symbol(),MODE_TICKSIZE)  * MarketInfo (Symbol(),MODE_TICKVALUE)*OrderLots();
               }
         break; 
         }
      int D = MarketInfo (Symbol(),MODE_DIGITS);
      
      
      Comment_Text = Select + ". "  + OrderTicket() + " " + PoType + 
         "\nLots: " + DoubleToStr(OrderLots(), 2) + "  P/L: " + DoubleToStr(OrderProfit(),2) + 
         "\nOpen: " + DoubleToStr(OrderOpenPrice(),D) + "  T: " + TimeToStr(OrderOpenTime()) +
         "\nStop:  " + DoubleToStr(OrderStopLoss(),D) + "  R: " + DoubleToStr(R,2) + "  W: " + DoubleToStr(W,2) +
         "\nTake: " + DoubleToStr(OrderTakeProfit(),D) + "  P: " + DoubleToStr(P,2) + "  B: " + DoubleToStr(B,2);  
      }
   else Comment_Text = "--no order selected--";
   
   double totallots, TrueLeverage;
   /*for (int lx = 0; lx < OrdersTotal(); lx ++)
      {
      OrderSelect(lx,SELECT_BY_POS);
      if (OrderType < 2) totallots = totallots + OrderLots;
      } */
   TrueLeverage = AccountMargin()/AccountEquity()*AccountLeverage(); 
   
   Comment_Text = Comment_Text + "\nTrue Leverage: " + DoubleToStr (TrueLeverage,3) + " : 1";
   
   Comment (Comment_Text);
   
   if (ObjectFind("Select") == -1)
   {
      ObjectCreate ("Select", OBJ_ARROW,0, Time[0] + Time_Unit*8, Bottom + Price_Unit*2.5); 
      ObjectSet ("Select", OBJPROP_ARROWCODE, 3);
      ObjectSet ("Select", OBJPROP_COLOR, Blue);
   }
   else
   {
       if (ObjectGet ("Select", OBJPROP_TIME1 ) < Time[0] && Shifted == false) 
         {
         Bottom_Fly = (ObjectGet ("Select", OBJPROP_PRICE1) - ((Bottom + Price_Unit*2.5) - Bottom_Fly*Price_Unit ) ) / Price_Unit;  
         Shifted = True;           
         }
       else
         {
         Shifted = False;     
         ObjectSet ("Select", OBJPROP_TIME1, Time[0] + Time_Unit*8); 
         ObjectSet ("Select", OBJPROP_PRICE1, Bottom + Price_Unit*2.5);  
         }          
   }
   
  
   if (Action_Line) 
   {
      if (ObjectFind("Action_Line") == -1)
      {
         ObjectCreate ("Action_Line", OBJ_VLINE, 0, Time[0]+Time_Unit, Bottom + Price_Unit);
         ObjectSet ("Action_Line", OBJPROP_COLOR, Text_Color);
      }
      else
      {
         ObjectSet ("Action_Line", OBJPROP_TIME1, Time[0]+Time_Unit);          
      }
   }
   
   
   if (ObjectFind("Safety") == -1)
   {
      ObjectCreate ("Safety", OBJ_ARROW, 0, Time[0] + Time_Unit*6, Bottom + Price_Unit*3);
      ObjectSet ("Safety", OBJPROP_ARROWCODE, SYMBOL_THUMBSUP);
   }
   else
   {
       ObjectSet ("Safety", OBJPROP_TIME1, Time[0] + Time_Unit*6);
       ObjectSet ("Safety", OBJPROP_PRICE1, Bottom + Price_Unit*3);
       if (!Action_Taken) ObjectSet ("Safety", OBJPROP_COLOR, Green); else ObjectSet ("Safety", OBJPROP_COLOR, Red);
            
   }
   
   if (ObjectFind("Stop_Loss_Icon") == -1)
   
   {
      ObjectCreate ("Stop_Loss_Icon", OBJ_TEXT, 0, Bottom + Price_Unit*5, Time[0] + Time_Unit*2); 
      ObjectSetText ("Stop_Loss_Icon", "----", Font_Size, Font, Red);
   }
   else
   {
       ObjectSet ("Stop_Loss_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*2);
       ObjectSet ("Stop_Loss_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }

   if (ObjectFind("Entry_Icon") == -1)
   {
      ObjectCreate ("Entry_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*4, Bottom + Price_Unit*5);
      ObjectSetText ("Entry_Icon", "----", Font_Size, Font, Blue);
   }
   else
   {
       ObjectSet ("Entry_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*4);
       ObjectSet ("Entry_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }
   
   if (ObjectFind("Alert_Icon") == -1)
   {
      ObjectCreate ("Alert_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*8, Bottom + Price_Unit*5);
      ObjectSetText ("Alert_Icon", "----", Font_Size, Font, Pink);
   }
   else
   {
       ObjectSet ("Alert_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*8);
       ObjectSet ("Alert_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }
   

   if (ObjectFind("Target1_Icon") == -1)
   {
      ObjectCreate ("Target1_Icon", OBJ_TEXT, 0, Time[0] + Time_Unit*6, Bottom + Price_Unit*5);
      ObjectSetText ("Target1_Icon", "----", Font_Size, Font, Green);
   }
   else
   {
       ObjectSet ("Target1_Icon", OBJPROP_TIME1, Time[0] + Time_Unit*6);
       ObjectSet ("Target1_Icon", OBJPROP_PRICE1, Bottom + Price_Unit*5);            
   }
   

   if (ObjectFind("Delete_Order") == -1)
   {
      
      ObjectCreate ("Delete_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*6 , Bottom + Price_Unit*4);
      ObjectSet ("Delete_Order", OBJPROP_ARROWCODE, SYMBOL_STOPSIGN);
      ObjectSet ("Delete_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Delete_Order", OBJPROP_TIME1, Time[0] + Time_Unit*6);
      ObjectSet ("Delete_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }

   if (ObjectFind("Update_Order") == -1)
   {
      
      ObjectCreate ("Update_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*8 , Bottom + Price_Unit*4);
      ObjectSet ("Update_Order", OBJPROP_ARROWCODE, SYMBOL_CHECKSIGN);
      ObjectSet ("Update_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Update_Order", OBJPROP_TIME1, Time[0] + Time_Unit*8);
      ObjectSet ("Update_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }

   
   if (ObjectFind("Market_Buy_Order") == -1)
   {
      
      ObjectCreate ("Market_Buy_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*2 , Bottom + Price_Unit*4);
      ObjectSet ("Market_Buy_Order", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
      ObjectSet ("Market_Buy_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Market_Buy_Order", OBJPROP_TIME1, Time[0] + Time_Unit*2);
      ObjectSet ("Market_Buy_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }
   

   if (ObjectFind("Market_Sell_Order") == -1)
   {
      
      ObjectCreate ("Market_Sell_Order", OBJ_ARROW, 0, Time[0] + Time_Unit*4 , Bottom + Price_Unit*4);
      ObjectSet ("Market_Sell_Order", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
      ObjectSet ("Market_Sell_Order", OBJPROP_COLOR, Red);
   }
   else
   {
      ObjectSet ("Market_Sell_Order", OBJPROP_TIME1, Time[0] + Time_Unit*4);
      ObjectSet ("Market_Sell_Order", OBJPROP_PRICE1, Bottom + Price_Unit*4);            
   }
   

   
   
   if (Stop_Loss != 0)
   {
      if (ObjectFind("Stop_Loss") == -1)
      {
         ObjectCreate ("Stop_Loss", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Stop_Loss);
         ObjectSet ("Stop_Loss", OBJPROP_COLOR, Red);      
      }
   }
   
   if (Entry != 0)
   {
      if (ObjectFind("Entry") == -1)
      {
         ObjectCreate ("Entry", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Entry);      
         ObjectSet ("Entry", OBJPROP_COLOR, Blue);      
      }
   }

   if (Target1 != 0)
   {
      if (ObjectFind("Target1") == -1)
      {
         ObjectCreate ("Target1", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , Target1);      
         ObjectSet ("Target1", OBJPROP_COLOR, Green);      
      }
   }
   
   if (AlertP != 0)
   {
      if (ObjectFind("Alert") == -1)
      {
         ObjectCreate ("Alert", OBJ_HLINE, 0, Time[0] + Time_Unit*2 , AlertP);      
         ObjectSet ("Alert", OBJPROP_COLOR, Pink);      
      }
   }

   

   if (ObjectFind("Risk_Reward") == -1)
   {
      ObjectCreate ("Risk_Reward", OBJ_TEXT,0, Time[0] + (Time_Unit*RR_Center/X_Adjust)+(Time_Unit) , Bottom + Price_Unit);
      ObjectSet ("Risk_Reward", OBJPROP_COLOR, Text_Color);                     
   }
   else
   {
      ObjectSet ("Risk_Reward", OBJPROP_TIME1, Time[0] + (Time_Unit*RR_Center/X_Adjust)+(Time_Unit));            
      ObjectSet ("Risk_Reward", OBJPROP_PRICE1, Bottom + Price_Unit);            
      ObjectSetText ("Risk_Reward", "R:R: "+ DoubleToStr( Risk_Reward, 2) +" : 1", Font_Size, Font, Text_Color);
   }
   
   if (ObjectFind("Selected_Trade") == -1)
   {
      ObjectCreate ("Selected_Trade", OBJ_TEXT, 0, Time[0] + (Time_Unit*ST_Center/X_Adjust)+(Time_Unit) , Bottom);
      ObjectSet ("Selected_Trade", OBJPROP_COLOR, Text_Color);                     
   }
   else
   {
      string SelectS = "" + Select;
      if (Select == -1) SelectS = "NEW";
      ObjectSet ("Selected_Trade", OBJPROP_TIME1, Time[0] + (Time_Unit*ST_Center/X_Adjust)+(Time_Unit));            
      ObjectSet ("Selected_Trade", OBJPROP_PRICE1, Bottom);            
      ObjectSetText ("Selected_Trade", "Order: "+ SelectS, Font_Size, Font, Text_Color);
   }


   
   switch (Risk_Management)
   {
      case 0:
      {
         if (ObjectFind("Lot_Size") == -1)
         {
            ObjectCreate ("Lot_Size", OBJ_TEXT, 0, Time[0] + (Time_Unit*LS0_Center/X_Adjust) +Time_Unit  , Bottom + Price_Unit*2);
            ObjectSet ("Lot_Size", OBJPROP_COLOR, Text_Color); 
                       
         }
         else
         {
            ObjectSet ("Lot_Size", OBJPROP_TIME1, Time[0] + (Time_Unit*LS0_Center/X_Adjust) +Time_Unit );            
            ObjectSet ("Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*2);            
            ObjectSetText ("Lot_Size", "Lot Size: "+ DoubleToStr( Lot_Size, Lot_Precision) , Font_Size, Font, Text_Color);
         }
         
         if (ObjectFind("Inc_Lot_Size") == -1)
         {
            ObjectCreate("Inc_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*2, Bottom + Price_Unit*3);
            ObjectSet ("Inc_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
            ObjectSet ("Inc_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Inc_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*2);            
            ObjectSet ("Inc_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         if (ObjectFind("Dec_Lot_Size") == -1)
         {
            ObjectCreate("Dec_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*4, Bottom + Price_Unit*3);
            ObjectSet ("Dec_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
            ObjectSet ("Dec_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Dec_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*4);            
            ObjectSet ("Dec_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         break;
      }
      
      
      case 1:
      {
         if (ObjectFind("Lot_Size") == -1)
         {
            ObjectCreate ("Lot_Size", OBJ_TEXT, 0, Time[0] + (Time_Unit*LS1_Center/X_Adjust) +Time_Unit , Bottom + Price_Unit*2);
            ObjectSet ("Lot_Size", OBJPROP_COLOR, Text_Color);                     
         }
         else
         {
            ObjectSet ("Lot_Size", OBJPROP_TIME1, Time[0] + (Time_Unit*LS1_Center/X_Adjust) +Time_Unit );            
            ObjectSet ("Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*2);            
            ObjectSetText ("Lot_Size", "Lots: "+ DoubleToStr( Lot_Size, Lot_Precision) +"  "+" E: "+DoubleToStr( Standard_Lot_Size, 1)+"%" , Font_Size, Font, Text_Color);
         }
         
         
         
         if (ObjectFind("Inc_Lot_Size") == -1) 
         {
            ObjectCreate("Inc_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*2, Bottom + Price_Unit*3);
            ObjectSet ("Inc_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
            ObjectSet ("Inc_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Inc_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*2);            
            ObjectSet ("Inc_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         
         
         if (ObjectFind("Dec_Lot_Size") == -1)
         {
            ObjectCreate("Dec_Lot_Size", OBJ_ARROW, 0, Time[0] + Time_Unit*4, Bottom + Price_Unit*3);
            ObjectSet ("Dec_Lot_Size", OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
            ObjectSet ("Dec_Lot_Size", OBJPROP_COLOR, Text_Color);             
         }
         else
         {
            ObjectSet ("Dec_Lot_Size", OBJPROP_TIME1, Time[0] + Time_Unit*4);            
            ObjectSet ("Dec_Lot_Size", OBJPROP_PRICE1, Bottom + Price_Unit*3);            
            
         }
         break;

      }
   }
}     
      
void Check_For_Inputs()
{
   if (ObjectFind("Market_Buy_Order") != -1)

   {
      if (ObjectGet("Market_Buy_Order", OBJPROP_TIME1) <= Time [0] )
      {
         //Imediately Place Order
         if (!Action_Taken) 
         {
            Buy_At_Market();
            Action_Taken = true;
         }
      }
   }
   
   if (ObjectFind("Market_Sell_Order") != -1)
   {
      if (ObjectGet("Market_Sell_Order", OBJPROP_TIME1) <= Time [0] )
      {
         //Imediately Place Order
         if (!Action_Taken) 
         {
            Sell_At_Market();
            Action_Taken = true;
         }
      }
   }
   
   
   if (ObjectFind("Safety") != -1)

   {
      if (ObjectGet("Safety", OBJPROP_TIME1) <= Time [0] )
      {
         //Reload Safety
         Action_Taken = false;


      }
   } 


   if (ObjectFind("Inc_Lot_Size") != -1)

   {
      if (ObjectGet("Inc_Lot_Size", OBJPROP_TIME1) <= Time [0] )
      {
         if (Risk_Management == 0)
            Standard_Lot_Size = Standard_Lot_Size + 1.0/MathPow(10,Lot_Precision);
         else
            Standard_Lot_Size = Standard_Lot_Size + 0.1;


      }
   }

   if (ObjectFind("Dec_Lot_Size") != -1)

   {
      if (ObjectGet("Dec_Lot_Size", OBJPROP_TIME1) <= Time [0] )
      {
         //Reload Safety
         if (Risk_Management == 0)
            Standard_Lot_Size = Standard_Lot_Size - 1.0/MathPow(10,Lot_Precision);
         else
            Standard_Lot_Size = Standard_Lot_Size - 0.1; 
   
      }
   } 
   
   if (ObjectFind("Stop_Loss") != -1)
   {
      Stop_Loss = ObjectGet("Stop_Loss", OBJPROP_PRICE1);          
   }
   else
   {
      Stop_Loss = 0;
      
   }
   if (ObjectFind("Stop_Loss_Icon") != -1)

   {
      if (ObjectGet("Stop_Loss_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Stop_Loss = ObjectGet("Stop_Loss_Icon", OBJPROP_PRICE1);
         ObjectSet("Stop_Loss", OBJPROP_PRICE1, Stop_Loss);
         
      }
   }
   

   if (ObjectFind("Entry") != -1)
   {
      Entry = ObjectGet("Entry", OBJPROP_PRICE1);          
   }
   else
   {
      Entry = 0;
      
   }
   if (ObjectFind("Entry_Icon") != -1)

   {
      if (ObjectGet("Entry_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Entry = ObjectGet("Entry_Icon", OBJPROP_PRICE1);
         ObjectSet("Entry", OBJPROP_PRICE1, Entry);
         
      }
   }

   if (ObjectFind("Target1") != -1)
   {
      Target1 = ObjectGet("Target1", OBJPROP_PRICE1);          
   }
   else
   {
      Target1 = 0;
      
   }
   if (ObjectFind("Target1_Icon") != -1)

   {
      if (ObjectGet("Target1_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Target1 = ObjectGet("Target1_Icon", OBJPROP_PRICE1);
         ObjectSet("Target1", OBJPROP_PRICE1, Target1);
         
      }
   }

   if (ObjectFind("Target2") != -1)
   {
      Target2 = ObjectGet("Target2", OBJPROP_PRICE1);          
   }
   else
   {
      Target2 = 0;
      
   }
   if (ObjectFind("Target2_Icon") != -1)

   {
      if (ObjectGet("Target2_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Target2 = ObjectGet("Target2_Icon", OBJPROP_PRICE1);
         ObjectSet("Target2", OBJPROP_PRICE1, Target2);
         
      }
   }

   if (ObjectFind("Target3") != -1)
   {
      Target3 = ObjectGet("Target3", OBJPROP_PRICE1);          
   }
   else
   {
      Target3 = 0;
      
   }
   if (ObjectFind("Target3_Icon") != -1)

   {
      if (ObjectGet("Target3_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Stop Loss
         Target3 = ObjectGet("Target3_Icon", OBJPROP_PRICE1);
         ObjectSet("Target3", OBJPROP_PRICE1, Target3);
         
      }
   }

   if (ObjectFind("Target4") != -1)
   {
      Target4 = ObjectGet("Target4", OBJPROP_PRICE1);          
   }
   else
   {
      Target4 = 0;
      
   }
   if (ObjectFind("Target4_Icon") != -1)

   {
      if (ObjectGet("Target4_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         
         Target4 = ObjectGet("Target4_Icon", OBJPROP_PRICE1);
         ObjectSet("Target4", OBJPROP_PRICE1, Target4);
         
      }
   }
   if (ObjectFind("Alert") != -1)
   {
      ObjectSet("Alert", OBJPROP_PRICE1, AlertP);         
   }
   else
   {
      AlertP= 0;
      {
         int xxx = 1;
         double GVNamex;
         //Alert (ASymbol);
         
         while (GlobalVariableCheck("_AlertP"+xxx))
            {
            GVNamex=GlobalVariableGet("_AlertS"+xxx) ;
            if (GVNamex==ASymbol) break;
            xxx = xxx + 1;
            }
         GlobalVariableSet("_AlertP"+xxx,AlertP)  ; 
         GlobalVariableSet("_AlertS"+xxx,ASymbol) ;           
         GlobalVariableSet("_AlertD"+xxx,0);
      }
      
      
   }
   if (ObjectFind("Alert_Icon") != -1)

   {
      if (ObjectGet("Alert_Icon", OBJPROP_TIME1) <= Time [0] )
      {
         //Place Alert
         AlertP = ObjectGet("Alert_Icon", OBJPROP_PRICE1);
         ObjectSet("Alert", OBJPROP_PRICE1, AlertP);
         ObjectSet("Alert", OBJPROP_STYLE, STYLE_DOT);
         int x = 1;
         double GVName;
         //Alert ("Alert set");
         
         while (GlobalVariableCheck("_AlertP"+x))
            {
            GVName=GlobalVariableGet("_AlertS"+x) ;
            if (GVName==ASymbol) break;
            x = x + 1;
            }
         GlobalVariableSet("_AlertP"+x,AlertP)  ; 
         GlobalVariableSet("_AlertS"+x,ASymbol) ;           
         if (AlertP > Bid) GlobalVariableSet("_AlertD"+x,1) ; // if price goes above alertP           
         if (AlertP < Bid) GlobalVariableSet("_AlertD"+x,2) ; // if price goes bellow alertP           

      }
   }



   if (ObjectFind("Lot_Size") != -1)

   {
      if (ObjectGet("Lot_Size", OBJPROP_TIME1) <= Time [0] )
      {
         
         Risk_Management++;
         if (Risk_Management > 1) Risk_Management = 0;
         Standard_Lot_Size = 0;
         
      }
   }

   if (ObjectFind("Delete_Order") != -1)
   {
      if (ObjectGet("Delete_Order", OBJPROP_TIME1) <= Time [0] )
      {
        if (Select > -1)
        {
         OrderSelect(Select,SELECT_BY_POS);
         if (OrderType()>1)
         {
            OResult = OrderDelete(OrderTicket());
            Alert("Closing Resting Order: "+OrderType()+" Ticket:"+OrderTicket() + "Error:" + GetLastError());
         } 
         else 
         {
            if (OrderType() == OP_BUY) OResult = OrderClose(OrderTicket(),Lot_Size,NormalizeDouble(Bid,Digits),Max_Slip);
            else OResult = OrderClose(OrderTicket(),Lot_Size,NormalizeDouble(Ask,Digits),Max_Slip);
            Alert("Closing Open Order: "+OrderType()+" Ticket:"+OrderTicket()+ " Error:" + GetLastError());

         }
         if (OResult==1)
            {
            Select = -1;               
            ObjectDelete ("Target1");
            Target1 = 0;
            ObjectDelete ("Stop_Loss");
            Stop_Loss = 0;
            ObjectDelete ("Entry");
            Entry = 0;
            }
        }
            
      }
   }

   if (ObjectFind("Update_Order") != -1)

   {
      if (ObjectGet("Update_Order", OBJPROP_TIME1) <= Time [0] )
      {
        OrderSelect(Select,SELECT_BY_POS);
        OrderModify(OrderTicket(),Entry,Stop_Loss,Target1,0);
        Alert ("ORDER MODIFIED "+Symbol()+ " E:" + Entry + " S:" + Stop_Loss + " T:" + Target1+ " ERROR:" +GetLastError());
       
      }
   }


   if (ObjectFind("Selected_Trade") != -1)
   {
      if (ObjectGet("Selected_Trade", OBJPROP_TIME1) <= Time [0] )
      {
         NoTradeFound = true;
         //Alert("deleting");
         ObjectDelete ("Target1");
         Target1 = 0;
         ObjectDelete ("Stop_Loss");
         Stop_Loss = 0;
         ObjectDelete ("Entry");
         Entry = 0;
         Risk_Management = 0;
         Standard_Lot_Size = 0;
         while (NoTradeFound)
         {
            Select ++;
    
            if (Select > OrdersTotal()) 
            {
               Select = -1;
               NoTradeFound = false;    
            }
            else
            {
               if (OrderSelect(Select, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() ) 
               {
                  //Alert("Found Active Order");
                  Stop_Loss = OrderStopLoss();
                  Target1 = OrderTakeProfit();
                  Entry = OrderOpenPrice(); 
                  Standard_Lot_Size = OrderLots();
                  NoTradeFound = false; 
                  
               }
            }
            
            
         }
         
         
      
      } 
   }

}

void Recalculate_Risk()
{
   
       {
         int xxx = 1;
         double GVNamex;
         double _AlertP;
         double _AlertS;
         double _AlertD;
         //Alert (ASymbol);
         
         while (GlobalVariableCheck("_AlertP"+xxx))
            {
            _AlertS = GlobalVariableGet("_AlertS"+xxx) ;
            if (_AlertS==1) XSymbol = "USDJPY";
            if (_AlertS==2) XSymbol = "USDCAD";
            if (_AlertS==3) XSymbol = "USDCHF";
            if (_AlertS==4) XSymbol = "GBPUSD";
            if (_AlertS==5) XSymbol = "AUDUSD";
            if (_AlertS==19) XSymbol = "EURUSD";
            if (_AlertS==6) XSymbol = "GBPJPY";
            if (_AlertS==7) XSymbol = "EURJPY";
            if (_AlertS==8) XSymbol = "USDCAD";
            if (_AlertS==9) XSymbol = "USDCHF";
            if (_AlertS==10) XSymbol = "XAGUSD";
            if (_AlertS==11) XSymbol = "XAUUSD";
            if (_AlertS==12) XSymbol = "NZDUSD";
            if (_AlertS==13) XSymbol = "AUDNZD";
            if (_AlertS==14) XSymbol = "EURGBP";
            if (_AlertS==15) XSymbol = "EURCHF";
            if (_AlertS==16) XSymbol = "CHFJPY";
            if (_AlertS==17) XSymbol = "GBPCHF";
            if (_AlertS==18) XSymbol = "AUDCAD";
            if (_AlertS==20) XSymbol = "USDMXN";
            if (_AlertS==21) XSymbol = "USDTRY";
            if (_AlertS==22) XSymbol = "CADJPY";
            if (_AlertS==23) XSymbol = "AUDJPY";
            if (_AlertS==24) XSymbol = "EURCAD";
            if (_AlertS==25) XSymbol = "EURAUD";
            _AlertP = GlobalVariableGet("_AlertP"+xxx);   
            _AlertD = GlobalVariableGet("_AlertD"+xxx);
            if (_AlertD == 1 && MarketInfo(XSymbol, MODE_BID) >= _AlertP) Alert("Alert Triggered For"+XSymbol + " xxx" + xxx + " _AlertS" + _AlertS + " _AlertP" + _AlertP + "_AlertD" + _AlertD);
            if (_AlertD == 2 && MarketInfo(XSymbol, MODE_BID) <= _AlertP) Alert("Alert Triggered For"+XSymbol + " xxx" + xxx + " _AlertS" + _AlertS + " _AlertP" + _AlertP + "_AlertD" + _AlertD);
            if (XSymbol == Symbol() && _AlertS != 0) AlertP = _AlertP;
            xxx = xxx + 1;
            
            }

   /*      
if (XSymbol == "USDJPY") ASymbol = 1;
if (XSymbol == "USDCAD") ASymbol = 2;
if (XSymbol == "USDCHF") ASymbol = 3;
if (XSymbol == "GBPUSD") ASymbol = 4;
if (XSymbol == "AUDUSD") ASymbol = 5;
if (XSymbol == "GBPJPY") ASymbol = 6;
if (XSymbol == "EURJPY") ASymbol = 7;
if (XSymbol == "USDCAD") ASymbol = 8;
if (XSymbol == "USDCHF") ASymbol = 9;
if (XSymbol == "XAGUSD") ASymbol = 10;
if (XSymbol == "XAUUSD") ASymbol = 11;
if (XSymbol == "NZDUSD") ASymbol = 12;
if (XSymbol == "AUDNZD") ASymbol = 13;
if (XSymbol == "EURGBP") ASymbol = 14;
if (XSymbol == "EURCHF") ASymbol = 15;
if (XSymbol == "CHFJPY") ASymbol = 16;
if (XSymbol == "GBPCHF") ASymbol = 17;
if (XSymbol == "AUDCAD") ASymbol = 18;
if (XSymbol == "EURUSD") ASymbol = 19;
if (XSymbol == "USDMXN") ASymbol = 20;
if (XSymbol == "USDTRY") ASymbol = 21;
if (XSymbol == "CADJPY") ASymbol = 22;
if (XSymbol == "AUDJPY") ASymbol = 23;
if (XSymbol == "EURCAD") ASymbol = 24;
if (XSymbol == "EURAUD") ASymbol = 25;
       */  
         
        // Alert (XSymbol);
      }

   
   
   
   if (Lot_Size < 0) Lot_Size =0;
   if (Standard_Lot_Size < 0) Standard_Lot_Size =0;
   if (Target1 !=0 && Stop_Loss !=0)
   {
      if (Entry != 0)
      {
         Risk_Reward = (Target1 - Entry) / (Entry - Stop_Loss) ;
      }
      else
      {
         Risk_Reward = (Target1 - Close[0]) / (Close[0] - Stop_Loss) ;
      }
      
   }
   else
   {
      Risk_Reward = 0;
   }   
   if (Risk_Management == 0)
   {
      Lot_Size = NormalizeDouble(Standard_Lot_Size,Lot_Precision);
   }   

   if (Risk_Management == 1)
   {  
      if (Stop_Loss != 0)
      {
         if (Entry != 0)
         {
            if (Stop_Loss > Entry)
            {
               if (Stop_Loss-Entry != 0)
               Lot_Size = (AccountEquity()*Standard_Lot_Size/100) / ((Stop_Loss-Entry)/Point*MarketInfo(Symbol(),MODE_TICKVALUE));
               //Alert("Lotsize:"+Lot_Size);     
            
            }
            else
            {
               if (Stop_Loss-Entry != 0)
               Lot_Size = (AccountEquity()*Standard_Lot_Size/100) / ((Entry-Stop_Loss)/Point*MarketInfo(Symbol(),MODE_TICKVALUE));

            }
         }
         else
         {
            if (Stop_Loss > Ask)
            {
               
               Lot_Size = (AccountEquity()*Standard_Lot_Size/100) / ((Stop_Loss-Ask)/Point*MarketInfo(Symbol(),MODE_TICKVALUE));

            }
            if (Stop_Loss < Bid)
            {
               Lot_Size = (AccountEquity()*Standard_Lot_Size/100) / ((Bid-Stop_Loss)/Point*MarketInfo(Symbol(),MODE_TICKVALUE));
            
            }
         }
         
       
      }
      else
      {
         Lot_Size = 0;
      }
   }   

}

void Buy_At_Market()
{
   if (Stop_Loss != 0)
   {
      TStop = NormalizeDouble(Stop_Loss,Digits);
   } 
   else
   {
      if (Default_Stop != 0) TStop = Ask - Default_Stop * Point; else TStop = 0;
   }
      
   if (Target1 != 0)
   {
      TTake1 = NormalizeDouble(Target1,Digits);
   } 
   else
   {
      if (Default_Take1 != 0) TTake1 = Ask + Default_Take1 * Point; else TTake1 = 0;
   }
/*
   if (Target2 != 0)
   {
      TTake2 = Target2;
   } 
   else
   {
      if (Default_Take2 != 0) TTake2 = Ask + Default_Take2 * Point; else TTake2 = 0;
   }

   if (Target3 != 0)
   {
      TTake3 = Target3;
   } 
   else
   {
      if (Default_Take3 != 0) TTake3 = Ask + Default_Take3 * Point; else TTake3 = 0;
   }

   if (Target4 != 0)
   {
      TTake4 = Target4;
   } 
   else
   {
      if (Default_Take4 != 0) TTake4 = Ask + Default_Take4 * Point; else TTake4 = 0;
   }
   */
   if (Entry == 0)   
   {
      OResult = OrderSend(Symbol(),OP_BUY,Lot_Size,NormalizeDouble(Ask,Digits),Max_Slip,TStop,TTake1,TimeCurrent()+Com,MagicNumber,0);
      Alert ("Buy_Market"+Symbol()+" "+OP_BUY+" "+Lot_Size+" "+Ask+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+Com+MagicNumber + " ERROR:" +GetLastError());
   }
   else
   {
      Entry = NormalizeDouble(Entry,Digits);
      if (Entry < Ask) OResult = OrderSend(Symbol(),OP_BUYLIMIT,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+Com,MagicNumber,0); 
      else OResult = OrderSend(Symbol(),OP_BUYSTOP,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+Com,MagicNumber,0);
      
      Alert ("Resting Order Buy "+Symbol()+" EO "+Lot_Size+" "+Entry+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+Com+MagicNumber + " ERROR:" +GetLastError());
   }
   //Entry = NormalizeDouble(Entry,);
   //if (Units_Per_Trade > 1) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake2,TimeCurrent()+"U2",MagicNumber,0);
   //if (Units_Per_Trade > 2) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake3,TimeCurrent()+"U3",MagicNumber,0);
   //if (Units_Per_Trade > 3) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake4,TimeCurrent()+"U4",MagicNumber,0);
   if (OResult != -1)
      {
      Select = OrdersTotal( )-1 ;  
      OrderSelect(Select, SELECT_BY_POS);  
      NoTradeFound = False;           
      //ObjectDelete ("Target1");
      //Target1 = 0;
      //ObjectDelete ("Stop_Loss");
      //Stop_Loss = 0;
      //ObjectDelete ("Entry");
      //Entry = 0;
      }
}


void Sell_At_Market()
{
   if (Stop_Loss != 0)
   {
      TStop = NormalizeDouble(Stop_Loss,Digits);
   } 
   else
   {
      if (Default_Stop != 0) TStop = Bid - Default_Stop * Point; else TStop = 0;
   }
      
   if (Target1 != 0)
   {
      TTake1 = NormalizeDouble(Target1,Digits);
   } 
   else
   {
      if (Default_Take1 != 0) TTake1 = Bid + Default_Take1 * Point; else TTake1 = 0;
   }
/*
   if (Target2 != 0)
   {
      TTake2 = Target2;
   } 
   else
   {
      if (Default_Take2 != 0) TTake2 = Bid + Default_Take2 * Point; else TTake2 = 0;
   }

   if (Target3 != 0)
   {
      TTake3 = Target3;
   } 
   else
   {
      if (Default_Take3 != 0) TTake3 = Bid + Default_Take3 * Point; else TTake3 = 0;
   }

   if (Target4 != 0)
   {
      TTake4 = Target4;
   } 
   else
   {
      if (Default_Take4 != 0) TTake4 = Bid + Default_Take4 * Point; else TTake4 = 0;
   }
   */
   if (Entry == 0)   
   {
      OResult = OrderSend(Symbol(),OP_SELL,Lot_Size,NormalizeDouble(Bid,Digits),Max_Slip,NormalizeDouble(TStop,Digits),NormalizeDouble(TTake1,Digits),TimeCurrent()+Com,MagicNumber,0);
      Alert ("Sell_Market"+Symbol()+" "+OP_SELL+" "+Lot_Size+" "+Bid+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+Com+MagicNumber + " Error:"+GetLastError());
   }
   else
   {
     Entry = NormalizeDouble(Entry,Digits);
     if (Entry < Bid) OResult = OrderSend(Symbol(),OP_SELLSTOP,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+Com,MagicNumber,0); 
     else OResult = OrderSend(Symbol(),OP_SELLLIMIT,Lot_Size,Entry,Max_Slip,TStop,TTake1,TimeCurrent()+Com,MagicNumber,0);
     Alert ("Sell_Resting"+Symbol()+" EO "+Lot_Size+" "+Bid+" "+Max_Slip+" "+TStop+" "+TTake1+" "+TimeCurrent()+Com+MagicNumber+ " Error:"+GetLastError());
   }
   
   
   //Entry = NormalizeDouble(Entry,);
   //if (Units_Per_Trade > 1) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake2,TimeCurrent()+"U2",MagicNumber,0);
   //if (Units_Per_Trade > 2) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake3,TimeCurrent()+"U3",MagicNumber,0);
   //if (Units_Per_Trade > 3) OrderSend(Symbol(),OP,Lot_Size,Entry,Max_Slip,TStop,TTake4,TimeCurrent()+"U4",MagicNumber,0);
   if (OResult != -1)
      {
      Select = OrdersTotal( )-1 ;  
      OrderSelect(Select, SELECT_BY_POS);  
      NoTradeFound = False;           
      //ObjectDelete ("Target1");
      //Target1 = 0;
      //ObjectDelete ("Stop_Loss");
      //Stop_Loss = 0;
      //ObjectDelete ("Entry");
      //Entry = 0;
      }

}       
        